//+------------------------------------------------------------------+
//|                          Williams' Accumulation/Distribution.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//----
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  clrLightSeaGreen
#property indicator_color2  clrRed

extern int            ADMaPeriod = 49;   
extern ENUM_MA_METHOD ADMaMode   = MODE_LWMA;  
//---- buffers
double Buffer1[];
double adma[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   
   SetIndexBuffer(0, Buffer1);
   SetIndexBuffer(1, adma);
   IndicatorShortName("W_A/D ("+ADMaPeriod+")");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           
   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      double TRH = MathMax(High[i], Close[i+1]);
      double TRL = MathMin(Low[i], Close[i+1]);
       if(Close[i] > Close[i+1] + Point)
         double AD = Close[i] - TRL;
       else 
       if(Close[i] < Close[i+1] - Point)   
               AD = Close[i] - TRH;
       else 
               AD = 0;
       Buffer1[i] = Buffer1[i+1] + AD;
   }
   for(i=limit; i>=0; i--)  adma[i] = iMAOnArray(Buffer1,0,ADMaPeriod,0,ADMaMode,i);
   return(0);
  }
//+------------------------------------------------------------------+